

(function(){ /* closure to prevent global pollution */
  
  var ele_button = null;
  var ele_dropdown = null;
  
  var highlighted = 0;
  
  window.deviceSelector = {
    
    init: function()
    {
      ele_button = g('screen-title-button');
      ele_dropdown = g('screen-title-dropdown');
      
      ele_button.addEventListener('click', function(evt)
      {
        g('screen-title').toggleClass('expanded');
        if (g('screen-title').hasClass('expanded'))
        {
          document.addEventListener('click', closeDropdown, true);
          document.addEventListener('mousedown', closeDropdown, true);
          document.addEventListener('keypress', keypress, false);
          highlighted = Control.getIndex();
          setHighlighted();
        }
        else
        {
          document.removeEventListener('click', closeDropdown, true);
          document.removeEventListener('mousedown', closeDropdown, true);
          document.removeEventListener('keypress', keypress, false);
        }
      }, false);
      
      ele_dropdown.addEventListener('click', function(evt)
      {
        if (evt.target.tagName.toLowerCase()!='button') { return; }
  
        var count = evt.target.getAttribute('_count');
        if (count)
        {
          chooseDevice(count);
        }
      }, false);
      
      g('screen-title-up').addEventListener('click', function()
      {
        var n = Control.getIndex()-1;
        if (n>=0)
        {
          chooseDevice(n);
        }
      }, false);
      
      g('screen-title-down').addEventListener('click', function()
      {
        var n = Control.getIndex()+1;
        if (n < Control.devices.length)
        {
          chooseDevice(n);
        }
      }, false);
    },
    
    update: function()
    {
      var frag = document.createDocumentFragment();
      var ele = null;

      for (var i=0; i<Control.devices.length; i++)
      {
        ele = document.createElement('button');
        ele.setAttribute('_count', i);
        ele.textContent = Control.devices[i].title;
        frag.appendChild(ele);
      }

      g('panel-title').textContent =
      ele_button.textContent = Control.device.settings.title;
      ele_dropdown.innerHTML = '';
      ele_dropdown.appendChild(frag);
      g('screen-title').removeClass('expanded');
      document.removeEventListener('click', closeDropdown, true);
      document.removeEventListener('mousedown', closeDropdown, true);

      g('screen-title-up').disabled = (Control.getIndex() < 1);
      g('screen-title-down').disabled = (Control.getIndex() >= Control.devices.length-1);
    }
  }
  
  function keypress(evt)
  {
    var buttons = null;
    
    switch (evt.keyCode)
    {
      case 38: // up key
        highlighted--;
        setHighlighted();
        break;
      
      case 40: // down key
        highlighted++;
        setHighlighted();
        break;
      
      case 13: // enter key
        chooseDevice(highlighted);
        evt.preventDefault();
    }
  }
  
  function setHighlighted()
  {
    var buttons = ele_dropdown.getElementsByTagName('button');
    
    // correct range
    highlighted = Math.max(0, Math.min(buttons.length-1, highlighted));
    
    // remove existing highlight
    if (ele_dropdown.getElementsByClassName('highlighted')[0])
    {
      ele_dropdown.getElementsByClassName('highlighted')[0].removeClass('highlighted');
    }
    
    // add new highlight
    buttons[highlighted].addClass('highlighted');
  }
  
  function chooseDevice(n)
  {
    g('screen-title').removeClass('expanded');
    ele_button.textContent = Control.devices[n].title;
    Control.loadDevice(Control.devices[n]);
  }
  
  function closeDropdown(evt)
  {
    if (!g('screen-title').hasChild(evt && evt.target))
    {
      g('screen-title').removeClass('expanded');
      document.removeEventListener('click', closeDropdown, true);
      document.removeEventListener('mousedown', closeDropdown, true);
      document.removeEventListener('keypress', keypress, false);
    }
  }

})();