
var messenger = {
  init: function()
  {
    
  },
  
  /**
   * Takes an object, turns it into a JSON string and posts it to the parent.
   * 
   * @param data {Object} The data object to send, should have a 'command' property
   */
  
  postMessage: function(data)
  {
    window.parent.postMessage(JSON.stringify(data), '*');
  },
  
  /**
   * Sends a command to the parent to close the window.
   */
  
  close: function()
  {
    messenger.postMessage({
      command: 'close'
    });
  },
  
  browseForWidget: function()
  {
    messenger.postMessage({
      command: 'browseForWidget'
    });
  },
  
  browseForDevices: function()
  {
    messenger.postMessage({
      command: 'browseForDevices'
    })
  }
};


var receiver = {
  
  listener: function(event)
  {
    var data = JSON.parse(event.data);
    receiver[data.command](data);
  },
  
  widgetAdded: function(data)
  {
    
    
  },
  
  alert: function(data)
  {
    ui.alert(data.title, data.text);
  }
  
};

window.addEventListener("message", receiver.listener, false);