(function(){
  
  window.tooltips = {
    init: function()
    {
      tooltip = document.createElement('div');
      tooltip.setAttribute('id', 'tooltip');
      document.body.appendChild(tooltip);
      
      document.addEventListener('mouseover', function(evt)
      {
        var ele = evt.target;
        while (ele && ele.getAttribute)
        {
          if (ele.getAttribute('data-tooltip'))
          {
            mouseover.call(ele, evt);
            return;
          }
          ele = ele.parentNode;
        }
        
      }, false);
    }
  };
  
  var tooltip = null;
  var timeout = 0;
  var ele = null;
  var active = null;
  var offsetWidth = 0;
  
  function mouseover(e)
  {
    if (timeout)
    {
      clearTimeout(timeout);
    }
    else
    {
      if (this == active) { return; }
      
      if (active)
      {
        opera.postError('h');
        hide();
      }
    }
    active = this;
    tooltip.textContent = active.getAttribute('data-tooltip');
    timeout = setTimeout(showTooltip, 400);
    active.addEventListener('mouseout', tooFast, false);
    document.addEventListener('mousedown', tooFast, false);
    document.addEventListener('mousemove', mousemove, false);
    mousemove(e);
  }
  
  function tooFast(evt)
  {
    clearTimeout(timeout);
    timeout = 0;
    active.removeEventListener('mouseout', tooFast, false);
    document.removeEventListener('mousedown', tooFast, false);
    document.removeEventListener('mousemove', mousemove, false);
    active = null;
  }
  
  function showTooltip()
  {
    timeout = 0;
    
    tooltip.style.visibility = 'visible';
    
    active.removeEventListener('mouseout', tooFast, false);
    document.removeEventListener('mousedown', tooFast, false);
    
    document.addEventListener('mousedown', hide, false);
    document.addEventListener('mouseout', hide, false);
    
    active.addEventListener('mouseout', hide, false);
  }
  
  function mousemove(evt)
  {
    var x = evt.clientX+13;
    var y = evt.clientY+5;
    
    tooltip.style.width = ''; // default to none
    tooltip.style.whiteSpace = ''
    
    // position the tooltip in a reasonable location within the screen
    if (window.innerWidth - tooltip.offsetWidth < x)
    {
      x = evt.clientX - tooltip.offsetWidth - 5;
      
      if (x<0)
      {
        tooltip.style.whiteSpace = 'normal';
        
        if (evt.clientX < 0.5*window.innerWidth)
        {
          x = evt.clientX + 13;
          tooltip.style.width = (window.innerWidth - x - 18) + 'px';
        }
        else
        {
          x = 3;
          tooltip.style.width = (evt.clientX - 25) + 'px';
        }
      }
    }
    if (window.innerHeight - tooltip.offsetHeight < y)
    {
      y = window.innerHeight - tooltip.offsetHeight;
    }
    tooltip.style.top = y + 'px';
    tooltip.style.left = x + 'px';
  }
  
  
  function hide()
  {
    if (!active) { return; }
    
    tooltip.style.visibility = 'hidden';
    
    document.removeEventListener('mousedown', hide, false);
    document.removeEventListener('mouseout', hide, false);
    
    active.removeEventListener('mouseout', hide, false);
    
    document.removeEventListener('mousemove', mousemove, false);
    
    active = null;
  }
})();